VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPublisher"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum PublisherErrors
    peNotFound = vbObjectError + 1
    peUpdatedByAnotherUser
End Enum

Public PubID           As Long
Public Name            As String
Public CompanyName     As String
Public Address         As String
Public City            As String
Public State           As String
Public Zip             As String
Public Telephone       As String
Public Fax             As String
Public LastModDateTime As Date

Friend Sub DBFetch(ByVal lDB As ADODB.Connection)
    Dim lSQL As String
    Dim lRS  As ADODB.Recordset

    lSQL = "SELECT * FROM Publishers"
    lSQL = lSQL & " WHERE PubID = " & CStr(PubID)

    Set lRS = lDB.Execute(lSQL)

    If lRS.EOF = True Then
        Call lRS.Close
        Call Err.Raise(peNotFound, "clsPublisher", "PubID " & CStr(PubID) & " not found.")
    End If

    Call RSGet(lRS)
    Call lRS.Close
End Sub

Friend Sub DBDelete(ByVal lDB As ADODB.Connection)
    Dim lSQL As String
    Dim lLastModDateTime As Date
    Dim lRS As ADODB.Recordset
    
    ' See if this Publisher has been changed since it was last fetched.

    lSQL = "SELECT LastModDateTime FROM Publishers"
    lSQL = lSQL & " WHERE PubID = " & CStr(PubID)

    Set lRS = lDB.Execute(lSQL)
    If lRS.EOF = True Then
        Call lRS.Close
        Call Err.Raise(peNotFound, "clsPublisher", "PubID " & CStr(PubID) & " not found.")
    End If

    lLastModDateTime = lRS!LastModDateTime
    Call lRS.Close
    
    If lLastModDateTime <> LastModDateTime Then
        Call Err.Raise(peUpdatedByAnotherUser, "clsStudent", _
            "Publisher ID = " & PubID & _
            " was updated by another user.  Update cannot be completed.")
    End If
    
    ' Delete this Publisher from the table.
    
    lSQL = "DELETE FROM Publishers"
    lSQL = lSQL & " WHERE PubID = " & CStr(PubID)

    Call lDB.Execute(lSQL)
End Sub

Friend Sub DBInsert(ByVal lDB As ADODB.Connection)
    Dim lSQL As String

    LastModDateTime = Now

    lSQL = "INSERT INTO Publishers ("

    lSQL = lSQL & "Name, "
    lSQL = lSQL & "[Company Name], "
    lSQL = lSQL & "Address, "
    lSQL = lSQL & "City, "
    lSQL = lSQL & "State, "
    lSQL = lSQL & "Zip, "
    lSQL = lSQL & "Telephone, "
    lSQL = lSQL & "Fax, "
    lSQL = lSQL & "LastModDateTime"
    

    lSQL = lSQL & ") SELECT "

    lSQL = lSQL & DBStr(Name) & ", "
    lSQL = lSQL & DBStr(CompanyName) & ", "
    lSQL = lSQL & DBStr(Address) & ", "
    lSQL = lSQL & DBStr(City) & ", "
    lSQL = lSQL & DBStr(State) & ", "
    lSQL = lSQL & DBStr(Zip) & ", "
    lSQL = lSQL & DBStr(Telephone) & ", "
    lSQL = lSQL & DBStr(Fax) & ", "
    lSQL = lSQL & DBDateTime(LastModDateTime)

    Call lDB.Execute(lSQL)
    
    ' Now query to get the PubID which was generated by the DBMS.
    lSQL = "SELECT MAX(PubID) AS NewID FROM Publishers"
    lSQL = lSQL & " WHERE Name = " & DBStr(Name)
    
    Dim lRS As ADODB.Recordset
    Set lRS = lDB.Execute(lSQL)

    If lRS.EOF = True Then
        Call lRS.Close
        Call Err.Raise(peNotFound, "clsPublisher", "PubID " & CStr(PubID) & " not found.")
    End If

    PubID = lRS!NewID
    Call lRS.Close
End Sub

Friend Sub DBUpdate(ByVal lDB As ADODB.Connection)
    Dim lSQL As String
    Dim lLastModDateTime As Date
    Dim lRS As ADODB.Recordset
    
    ' See if this Publisher has been changed since it was last fetched.

    lSQL = "SELECT LastModDateTime FROM Publishers"
    lSQL = lSQL & " WHERE PubID = " & CStr(PubID)

    Set lRS = lDB.Execute(lSQL)
    If lRS.EOF = True Then
        Call lRS.Close
        Call Err.Raise(peNotFound, "clsPublisher", "PubID " _
            & CStr(PubID) & " not found.")
    End If

    lLastModDateTime = lRS!LastModDateTime
    Call lRS.Close
    
    If lLastModDateTime <> LastModDateTime Then
        Call Err.Raise(peUpdatedByAnotherUser, "clsStudent", _
            "Publisher ID = " & PubID & _
            " was updated by another user.  Update cannot be completed.")
    End If
    
    ' Update this record with the new property values.
    
    LastModDateTime = Now
    
    lSQL = "UPDATE Publishers SET "

    lSQL = lSQL & " Name = " & DBStr(Name) & ","
    lSQL = lSQL & " [Company Name] = " & DBStr(CompanyName) & ","
    lSQL = lSQL & " Address = " & DBStr(Address) & ","
    lSQL = lSQL & " City = " & DBStr(City) & ","
    lSQL = lSQL & " State = " & DBStr(State) & ","
    lSQL = lSQL & " Zip = " & DBStr(Zip) & ","
    lSQL = lSQL & " Telephone = " & DBStr(Telephone) & ","
    lSQL = lSQL & " Fax = " & DBStr(Fax) & ","
    lSQL = lSQL & " LastModDateTime = " & DBDateTime(LastModDateTime)
    
    lSQL = lSQL & " WHERE PubID = " & CStr(PubID)

    Call lDB.Execute(lSQL)
End Sub

Friend Sub RSGet(ByVal lRS As ADODB.Recordset)
    ' Note that concatenating an empty string to the
    ' recordset fields prevents any errors caused by
    ' null fields.
    PubID = lRS!PubID
    Name = "" & lRS!Name
    CompanyName = "" & lRS![Company Name]
    Address = "" & lRS!Address
    City = "" & lRS!City
    State = "" & lRS!State
    Zip = "" & lRS!Zip
    Telephone = "" & lRS!Telephone
    Fax = "" & lRS!Fax
    LastModDateTime = lRS!LastModDateTime
End Sub
