VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPublisherList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Private PublisherList variables.
Private mDB As ADODB.Connection

' Automatically open a database connection when a PublisherList
' object is created.
Private Sub Class_Initialize()
    Dim lConnectString As String
    lConnectString = "Driver={Microsoft Access Driver (*.mdb)}; DBQ=" & App.Path & "\Biblio.mdb"
    Set mDB = New ADODB.Connection
    Call mDB.Open(lConnectString)
End Sub

' Automatically close the database connection when a PublisherList
' object is destroyed.
Private Sub Class_Terminate()
    Call mDB.Close
    Set mDB = Nothing
End Sub

' Removes a Publisher from the Publishers table.
Public Sub Delete(ByVal lPublisher As clsPublisher)
    Call lPublisher.DBDelete(mDB)
End Sub

' Inserts a Publisher into the Publishers table.
Public Sub Insert(ByVal lPublisher As clsPublisher)
    Call lPublisher.DBInsert(mDB)
    ' If we were worried about duplicate primary keys,
    ' we would attempt to catch the error raised by
    ' the DBMS here, and re-raise a nicer message.
End Sub

' Retrieves a Publisher from the Publishers table.
Public Function Fetch(ByVal lPubID As Long) As clsPublisher
    Dim lPub As clsPublisher
    Set lPub = New clsPublisher
    lPub.PubID = lPubID
    Call lPub.DBFetch(mDB)
    Set Fetch = lPub
End Function

' Updates a Publisher in the Publishers table.
Public Sub Update(ByVal lPublisher As clsPublisher)
    Call lPublisher.DBUpdate(mDB)
End Sub

' Returns a new collection containing a list of references to
' Publishers objects with a Name that matches the search criteria.
Public Function Search(ByVal lSearchString As String) As Collection
    Dim lSQL          As String
    Dim lPublisher    As clsPublisher
    Dim lPublisherCol As Collection
    Dim lRS           As ADODB.Recordset
    
    ' Build the SQL statement.
    lSQL = "SELECT * FROM Publishers " _
        & " WHERE Name LIKE " & DBStr("%" & lSearchString & "%") _
        & " ORDER BY Name"
    
    ' Query the database for the matching Publishers and create a
    ' new clsPublisher object for each record returned.
    Set lPublisherCol = New Collection
    Set lRS = mDB.Execute(lSQL)
    
    Do Until lRS.EOF = True
        Set lPublisher = New clsPublisher
        Call lPublisher.RSGet(lRS)
        Call lPublisherCol.Add(lPublisher, CStr(lPublisher.PubID))
        Call lRS.MoveNext
    Loop
    Call lRS.Close
    
    Set Search = lPublisherCol
End Function
